package com.huimv.wine.ws;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.huimv.wine.entity.Worker;
import com.huimv.wine.entity.vo.WsEvent;
import com.huimv.wine.mapper.WorkerMapper;
import com.huimv.wine.utils.*;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.web.socket.WebSocketMessage;
import org.springframework.web.socket.handler.TextWebSocketHandler;
import sun.nio.cs.ext.MacArabic;

import javax.websocket.*;
import javax.websocket.server.PathParam;
import javax.websocket.server.ServerEndpoint;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * websocket接口处理类
 */
@Component
@ServerEndpoint(value = "/worker/{token}")
public class WorkerController extends TextWebSocketHandler {

    /**
     * 连接事件，加入注解
     */



    @OnOpen
    public void onOpen(@PathParam(value = "token") String token, Session session) {
        // 添加到session的映射关系中
        WebsocketWorkerUtil.addSession(token, session);
        getSecrets(session);
    }



    private void getSecrets(Session session) {
        Map map = new HashMap();
        map.put("public",KeyUtil.getClientPublic());
        map.put("private",KeyUtil.getClientPrivate());
        WsEvent wsEvent = new WsEvent("secrets",map);
        WebsocketWorkerUtil.sendMessage(session,wsEvent);
    }

    /**
     * 连接事件，加入注解
     * 用户断开链接
     */
    @OnClose
    public void onClose(@PathParam(value = "token") String token, Session session) {
        // 删除映射关系
        WebsocketWorkerUtil.removeSession(token);
    }

    /**
     * 当接收到用户上传的消息
     */
    @OnMessage
    public void onMessage(@PathParam(value = "token") String token, Session session, String message) {
        String msg = "[" + token + "]:" + message;
        System.out.println("接收到信息：" + msg);

        JSONObject jsonObject = JSON.parseObject(message);
        String event = jsonObject.getString("event");
        JSONObject data = jsonObject.getJSONObject("data");

        if ("login".equals(event)){
            login(session,token,data);
        }

        RedisTemplate redisTemplate = SpringContextUtil.getBean(RedisTemplate.class);
        if (!redisTemplate.hasKey(token)){
            WsEvent wsEvent = new WsEvent("tokenExpired",null);
            WebsocketWorkerUtil.sendMessage(session,wsEvent);
        }else {
//            switch (event){
//                case ""
//            }
        }





//        switch (event) {
//            case "pin":
//                keepAlive(session);
//                break;
//            case "query":
//                query(session, data);
//                break;
//            case "detail":
//                detail(data);
//                break;
//            case "ready":
//                ready(session, data);
//                break;
//            case "finish":
//                finish(session, data);
//                break;
//            default:
//                sendError(session, "unrecognized event");
//                break;
//        }
    }

    private void login(Session session, String token, JSONObject data) {
        WorkerMapper WorkerMapper = SpringContextUtil.getBean(WorkerMapper.class);

        String account = data.getString("account");
        String password = data.getString("password");

        String serverPrivate = KeyUtil.getServerPrivate();
        String realPassword = RSAUtil.decrypt1(password, serverPrivate);
//        Worker worker = WorkerMapper.login(account,realPassword);
//        if (ObjectUtil.isEmpty(worker)){
//            WsEvent wsEvent = new WsEvent("loginResult",new Result());
//            WebsocketWorkerUtil.sendMessage(session,wsEvent);
//        }



    }

    private void loginSocket(String message, Session session) {

    }

    /**
     * 处理用户活连接异常
     *
     * @param session
     * @param throwable
     */
    @OnError
    public void onError(Session session, Throwable throwable) {
        try {
            session.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        throwable.printStackTrace();
    }
}
